#N canvas 891 244 957 147 10;
#X obj 42 34 bng 15 250 50 0 empty \$0-makeMarkov makeMarkov 17 7 0
10 -257985 -1 -1;
#X obj 42 53 ofelia d -c11 -k \$0-makeMarkov;
#A set function ofelia.bang() \; math.randomseed(os.time()- os.clock()
* 1000) \; -- make dictionary \; function defaultdict(default_value_factory)
\; local t = {} \; local metatable = {} \; metatable.__index = function(t
\, key) \; if not rawget(t \, key) then \; rawset(t \, key \, default_value_factory(key))
\; end \; return rawget(t \, key) \; end \; return setmetatable(t \,
metatable) \; end \; \; \; print('Learning model...') -- make markov
matrix \; STATE_LEN = 4 \; model = defaultdict(function() return {}
end) data = "100100101001000000010010011111111000111111110111010101010000000101111111111011111110111111111011111110000010100010"
\; datasize = #data \; print("data: " \, data) \; print("datasize:
" \, #data) \; data = data .. data:sub(1 \, STATE_LEN) \; print("altered
data: " \, data) \; print("altered datasize: " \, #data) \; for i =
1 \, (#data - STATE_LEN) do \; state = data:sub(i \, i + STATE_LEN-1)
\; -- print("state: " \, state) local next = data:sub(i + STATE_LEN
\, i + STATE_LEN) \; -- print("next: " \, next) \; model[state][next]
= (model[state][next] or 0)+1 \; end \; \; \; -- make markov chain
\; print('Sampling...') \; \; local keyTbl = {} \; local nexTbl = {}
\; local prbTbl = {} \; for key \, value in pairs(model) do \; for
k \, v in pairs(value) do \; table.insert(keyTbl \, key) \; table.insert(nexTbl
\, k) \; table.insert(prbTbl \, v) \; end \; end \; print ("keyTbl:
" \, table.unpack(keyTbl)) \; print ("nexTbl: " \, table.unpack(nexTbl))
\; print ("prbTbl: " \, table.unpack(prbTbl)) \; \; \; -- make random
key \; local randomKey = keyTbl[math.random(#keyTbl)] \; state = randomKey
\; print("RandomKey: " \, randomKey) \; \; -- make table from random
key \; local str = state \; local stateTable = {} \; for i = 1 \, #str
do \; stateTable[i] = str:sub(i \, i) \; end \; \; out = stateTable
\; print ("random key as table: " \, table.unpack(out)) \; \; -- make
markov chain \; for i = 1 \, 400 do \; \; -- weighted random choices
\; local choices = {} \; local weights = {} \; for j = 1 \, #keyTbl
do \; if state == keyTbl[j] then \; table.insert(choices \, nexTbl[j])
\; table.insert(weights \, prbTbl[j]) \; end \; end \; -- print ("choices:"
\, table.unpack(choices)) \; -- print ("weights:" \, table.unpack(weights))
\; \; local totalWeight = 0 \; for _ \, weight in pairs(weights) do
\; totalWeight = totalWeight + weight \; end \; rand = math.random()
* totalWeight \; local choice = nil \; for i \, weight in pairs(weights)
do \; if rand < weight then \; choice = choices[i] \; choice = choice:sub(1
\, 1) \; break \; else \; rand = rand - weight \; end \; end \; \;
table.insert(out \, choice) \; state = string.sub(state \, 2 \, #state)
.. out[#out] \; -- print("choice" \, choice) \; -- print ("state" \,
state) \; end \; \; print(table.concat(out)) \; return out \; end \;
;
#X obj 42 82 print;
#X connect 0 0 1 0;
#X connect 1 0 2 0;
